#include "Garmin.h"

/* --------------------------------------------------------------------------------- */

char *toDMS(double a)
{
	short neg=0;
	double d, m, s;
	static char dms[20];
	
	if (a < 0.0) {
		a = -a;
		neg = 1;
	}
	d = floor(a);
	a = (a - d) * 60.0;
	m = floor(a);
	s = (a - m) * 60.0;
	
	if (s > 59.5) {
		s = 0.0;
		m += 1.0;
	}
	if (m > 59.5) {
		m = 0.0;
		d += 1.0;
	}
	if (neg)
		d = -d;

	sprintf(dms, "%.0f%02.0f'%04.1f\"", d, m, s);
	return dms;
}

/* --------------------------------------------------------------------------------- */

double DMStoDegrees(char *dms)
{
	short d, m, neg = 0;
	double s;
	
	sscanf(dms, "%d%d%lf", &d, &m, &s);

	s = (double)(abs(d)) + ((double)m + s / 60.0) / 60.0;
	
	if (d >= 0)
		return s;
	else
		return -s;
}

/* --------------------------------------------------------------------------------- */

char *toDM(double a)
{
	short neg=0;
	double d, m;
	static char dm[13];
	
	if (a < 0.0) {
		a = -a;
		neg = 1;
	}
	d = floor(a);
	m = (a - d) * 60.0;

	if (m > 59.5) {
		m = 0.0;
		d += 1.0;
	}
	if (neg)
		d = -d;

	sprintf(dm, "%.0f%06.3f'", d, m);
	return dm;
}

/* --------------------------------------------------------------------------------- */

double DMtoDegrees(char *dms)
{
	short d, neg = 0;
	double m;
	
	sscanf(dms, "%d%lf", &d, &m);

	m = (double)(abs(d)) + m / 60.0;
	
	if (d >= 0)
		return m;
	else
		return -m;
}
