#include "Garmin.h"

static const double lat0 = 0.0;	// reference transverse mercator latitude
static const double k0 = 0.9996;

void DegToUTM(double lat, double lon, char *zone, double *x, double *y)
{
	char nz;
	double lon0;
	
	if ((lat >= -80.0) && (lat <= 84.0)) {
		nz = 'C'+((short)(lat + 80.0)) / 8;
		if (nz > 'H') ++nz;					// skip 'I' and 'O'
		if (nz > 'N') ++nz;
		lon0 = 6.0 * floor(lon / 6.0) + 3.0;	
		sprintf(zone, "%02d\t%c", ((short)lon0 +183) / 6, nz);
		toTM(lat, lon, lat0, lon0, k0, x, y);
		*x += 500000.0;				// false easting
		if (lat < 0.0)				// false northing for southern hemisphere
			*y = 10000000.0 - *y;
	}
	else {
		strcpy(zone, "00\tx");		
		if (lat > 0.0)
			if (lon < 0.0) zone[3] = 'Y';
					  else zone[3] = 'Z';
		else
			if (lon < 0.0) zone[3] = 'A';
					  else zone[3] = 'B';
		toUPS(lat, lon, x, y);
	}
}

/* --------------------------------------------------------------------------------- */

void UTMtoDeg(short zone, short southernHemisphere, double x, double y, double *lat, double *lon)
{
	double lon0;
	
	if (zone != 0) {
		lon0 = (double)((-183 + 6 * zone));
		if (southernHemisphere)
			y = 1.0e7 - y;			// remove false northing for southern hemisphere
		x -= 500000.0;				//   and false easting
		fromTM(x, y, lat0, lon0, k0, lat, lon);
	}
	else
		fromUPS(southernHemisphere, x, y, lat, lon);
}

