#define NMEA_LL_DLOG 132
#define NMEA_UTM_DLOG 133

#define ESCAPECHAR 0x1B

#define OUTDRIVER "\p.AOut"
#define INDRIVER "\p.AIn"

#define GPGGA "GPGGA"
#define GPGSA "GPGSA"
#define GPRMC "GPRMC"

struct OUTDATA{
	char utc[20];		// UTC date and time in format "mm/dd/yy hh:mm:ss"
	double latitude;	// Latitude and longitude in format "d.ddddd"
	double longitude;
	double altitude;	// Altitude in meters
	double speed;		// Speed over ground, knots
	double track;		// Track made good, degress True
	short satellites;		// Number of satellites used in solution
	short mode;			// 1 = no fix, 2 = 2D, 3 = 3D
	double pdop;		// Position dilution of precision
	double hdop;		// Horizontal dilution of precision
	double vdop;		// Vertical dilution of precision
};

/* prototypes */
void doNMEA(short refNum);
void processGPRMC(char *sentence);
void processGPGGA(char *sentence);
void processGPGSA(char *sentence);
short checksum(char *sentence);

// NMEA dialog data text items
#define NMEA_DAT	1
#define NMEA_LAT	2
#define NMEA_EAST	2
#define NMEA_LON	3
#define NMEA_NORTH	3
#define NMEA_ALT	4
#define NMEA_VEL	5
#define NMEA_TRK	6
#define NMEA_SAT	7
#define NMEA_MODE	8
#define NMEA_PDOP	9
#define NMEA_HDOP	10
#define NMEA_VDOP	11
#define NMEA_UTM	26