#include "MacInterface.h"

static void ChaseTheButton(DialogPtr dialog);

/* --------------------------------------------------------------------------------- */

/*
	display about dialog until itemHit == 1 (the picture) or each of the three buttons
	(items 2, 3 and 4) have been hit.
*/

void doAbout()
{
	DialogPtr aboutDialog;
	short itemHit, itemsHit = 0;

	aboutDialog = GetNewDialog(ABOUT_DLOG, 0L, (WindowPtr)-1L);
	SetPort(aboutDialog);
	ShowWindow(aboutDialog);
	do {
		ModalDialog(0L, &itemHit);
		if (itemHit != 1) {
			ChaseTheButton(aboutDialog);
			itemsHit |= 1<<(itemHit-2);
		}
	}
	while(itemHit != 1 && itemsHit != 7);
	DisposDialog(aboutDialog);
}

/* --------------------------------------------------------------------------------- */

void HighliteButton(DialogPtr dialog, short itemNo, Pattern pat)
{
	short itemType;
	Handle item;
	Rect box;
	PenState ps;
	
	GetDItem(dialog, itemNo, &itemType, &item, &box);
	GetPenState(&ps);
	PenNormal();
	PenPat(&pat);
	PenSize(3, 3);
	InsetRect(&box, -4, -4);
	FrameRoundRect(&box, 16, 16);
	SetPenState(&ps);
}

/* --------------------------------------------------------------------------------- */

static void ChaseTheButton(DialogPtr dialog)
{
	short i;
	
	for (i=2; i<=4; i++)
		HighliteButton(dialog, i, qd.white);
		
	if ( (i = Random()) < -32768/3 )
		i = 2;
	else if ( i < 32768/3 )
		i = 3;
	else
		i = 4;
	HighliteButton(dialog, i, qd.black);
}
