#include "MacInterface.h"
#include "Garmin.h"

static const long BUF_SIZE = 1024L;

/* --------------------------------------------------------------------------------- */

short GetLine(short refNum, char *line, short init)
{
	static char buffer[BUF_SIZE];
	static char *bufPtr;
	static long bytesInBuf;
	static enum {
		NEW,
		BUSY,
		END
	} state;
	
	char *lineStart = line;
	short result;
	
	if (init)
		state = NEW;
		
	while (line - lineStart < MAX_LINE) {

		switch (state) {
			case NEW:
				bufPtr = buffer + BUF_SIZE;
				state = BUSY;
				break;
								
			case BUSY:
				if (bufPtr - buffer == BUF_SIZE) {
					bytesInBuf = BUF_SIZE;
					switch ( result = FSRead(refNum, &bytesInBuf, buffer)) {
						case noErr:
							break;
							
						case eofErr:
							state = END;
							break;
						
						default:
							*line = '\0';
							state = NEW;
							return 0;
					}
					bufPtr = buffer;
				}
				*line++ = *bufPtr++;
				*line = '\0';
				if (*(line-1) == '\r')
					return 1;
				break;
			
			case END:
				if (bufPtr - buffer == bytesInBuf) {
					*line = '\0';
					state = NEW;
					return 0;
				}
				else {
					*line++ = *bufPtr++;
					*line = '\0';
					if (*(line-1) == '\r')
						return 1;
				}
				break;
		}
	}
	/* exit here if line is MAX_LINE and no carriage return */
	*line = '\0';
	return 0;
}
