#include "MacInterface.h"

static const short TOP    = 50;
static const short BOTTOM = 75;
static const short LEFT   = 10;
static const short RIGHT  = 390;
static const short BORDER = 2;

#define LINE1_LOC 10,20		// Text location for progress graph
#define LINE2_LOC 10,36

#define WINDOW_BOUNDS 75,55,160,455

static WindowRecord progressWindow;

/* --------------------------------------------------------------------------------- */

void SetBarGraph(double value)
{
	Rect bar;
	
	value = value<1.0 ? value : 1.0;
	value = value>0.0 ? value : 0.0;
	bar.top = TOP + BORDER;
	bar.bottom = BOTTOM - BORDER;
	bar.left = LEFT + BORDER;
	bar.right = bar.left + (short)( value * (float)(RIGHT - LEFT - 2 * BORDER) );
	
	FillRect(&bar, &qd.gray);
}

/* --------------------------------------------------------------------------------- */

void InitBarGraph()
{
	unsigned char title[] = "\p";
	Rect windowBounds = {WINDOW_BOUNDS};
	Rect graph;

	NewWindow(&progressWindow, &windowBounds, title, TRUE, dBoxProc,
					(WindowPtr)-1L, FALSE, 0L);
	ShowWindow((WindowPtr)&progressWindow);
	SetPort((GrafPtr)&progressWindow);

	graph.top = TOP;
	graph.bottom = BOTTOM;
	graph.left = LEFT;
	graph.right = RIGHT;
	PenSize(BORDER, BORDER);
	ForeColor(blueColor);
	FrameRect(&graph);
	
	ForeColor(blackColor);
	MoveTo(LINE1_LOC);
	TextFont(systemFont);
	TextSize(12);
	DrawString("\pTransferring GPS Data.");
	ForeColor(redColor);
}

/* --------------------------------------------------------------------------------- */

void CloseBarGraph()
{	
	DisposeWindow((WindowPtr)&progressWindow);
}
